local Sets = {};
local origTooltips = {};
local base, vendor


-- ---------------------------------------------------------------------------
-- Localization strings

-- raid role
local HEAL = "("..HEALER..")"
local TANK = "("..TANK..")"
local DPS = "("..DAMAGER..")"
local RDPS = "("..RANGED.." "..DAMAGER..")"
local MDPS = "("..MELEE.." "..DAMAGER..")"
local FERAL = "("..MELEE..")"

-- set quality
local EMBLEMS = MERCHANT
if GetLocale() == "enUS" then
  EMBLEMS = "Emblems"
end
local LFR = PLAYER_DIFFICULTY3
local FLEX = PLAYER_DIFFICULTY4
local RAID10 = RAID_DIFFICULTY_10PLAYER
local RAID25 = RAID_DIFFICULTY_25PLAYER
local NORMAL = PLAYER_DIFFICULTY1
local HEROIC = ITEM_HEROIC
local HEROIC10 = RAID_DIFFICULTY_10PLAYER_HEROIC
local HEROIC25 = RAID_DIFFICULTY_25PLAYER_HEROIC

local TOKEN = TOKENS:gsub("s$","")
local VENDOR = BATTLE_PET_SOURCE_3

local classes = {}
FillLocalizedClassList(classes)
local DRUID = classes.DRUID
local HUNTER = classes.HUNTER
local MAGE = classes.MAGE
local PALADIN = classes.PALADIN
local PRIEST = classes.PRIEST
local ROGUE = classes.ROGUE
local SHAMAN = classes.SHAMAN
local WARLOCK = classes.WARLOCK
local WARRIOR = classes.WARRIOR
local DEATHKNIGHT = classes.DEATHKNIGHT
local MONK = classes.MONK
-- ---------------------------------------------------------------------------
local function vmap(a_map, a_x, a_y, h_map, h_x, h_y)
  local map, x, y = a_map, a_x, a_y
  if h_map and UnitFactionGroup("player") == "Horde" then
     map, x, y = h_map, h_x, h_y
  end
  local loc = GetMapNameByID(map)
  if loc and x and y then
     loc = loc .. " ("..x..", "..y..")"
  end
  return loc
end
-- ---------------------------------------------------------------------------
local function RegisterSet(role, quality, ...)
	local n = select("#",...)
	local name = (base or "")
	if role then
	  name = name .. (#name > 0 and " " or "") .. role
	end
	if quality then
	  name = name .. (#name > 0 and " " or "") .. "[" .. quality .. "]"
	end		
	if role == TOKEN and vendor then
	  name = name .. "\n" .. VENDOR .. ": " .. vendor
	end
	for i = 1,n do
		local v = select(i,...)
                if Sets[v] then
                   print("TierTooltip: ERROR: duplicate itemid "..v.." : "..Sets[v].." : "..name)
                end
		Sets[v] = name;
	end
end

local function SetupSets()
-- ---------------------------------------------------------------------------
base = DUNGEON_FLOOR_RUINSOFAHNQIRAJ1
RegisterSet(DRUID,nil,   21407,21409,21408);
RegisterSet(HUNTER,nil,  21401,21403,21402);
RegisterSet(MAGE,nil, 	 21413,21415,21414);
RegisterSet(PALADIN,nil, 21395,21397,21396);
RegisterSet(PRIEST,nil,  21410,21412,21411);
RegisterSet(ROGUE,nil, 	 21404,21406,21405);
RegisterSet(SHAMAN,nil,  21398,21400,21399);
RegisterSet(WARLOCK,nil, 21416,21418,21417);
RegisterSet(WARRIOR,nil, 21392,21394,21393);
-- ---------------------------------------------------------------------------
base = DUNGEON_FLOOR_AHNQIRAJ3
RegisterSet(DRUID,nil,   21357,21353,21356,21354,21355);
RegisterSet(HUNTER,nil,  21370,21366,21368,21367,21365);
RegisterSet(MAGE,nil, 	 21343,21347,21346,21345,21344);
RegisterSet(PALADIN,nil, 21389,21387,21390,21391,21388);
RegisterSet(PRIEST,nil,  21351,21348,21352,21350,21349);
RegisterSet(ROGUE,nil, 	 21364,21360,21362,21361,21359);
RegisterSet(SHAMAN,nil,  21374,21372,21375,21376,21373);
RegisterSet(WARLOCK,nil, 21334,21337,21336,21335,21338);
RegisterSet(WARRIOR,nil, 21331,21329,21332,21330,21333);
-- ---------------------------------------------------------------------------
base = "D1"
RegisterSet(DRUID,nil, 	 16720,16718,16706,16714,16717,16716,16719,16715);
RegisterSet(HUNTER,nil,  16677,16679,16674,16681,16676,16680,16678,16675);
RegisterSet(MAGE,nil, 	 16686,16689,16688,16683,16684,16685,16687,16682);
RegisterSet(PALADIN,nil, 16727,16729,16726,16722,16724,16723,16728,16725);
RegisterSet(PRIEST,nil,  16693,16695,16690,16697,16692,16696,16694,16691);
RegisterSet(ROGUE,nil, 	 16707,16708,16721,16710,16712,16713,16709,16711);
RegisterSet(SHAMAN,nil,  16667,16669,16666,16671,16672,16673,16668,16670);
RegisterSet(WARLOCK,nil, 16698,16701,16700,16703,16705,16702,16699,16704);
RegisterSet(WARRIOR,nil, 16731,16733,16730,16735,16737,16736,16732,16734);
-- ---------------------------------------------------------------------------
base = "D2"
RegisterSet(DRUID,nil,   22109,22112,22113,22108,22110,22106,22111,22107);
RegisterSet(HUNTER,nil,  22013,22016,22060,22011,22015,22010,22017,22061);
RegisterSet(MAGE,nil,    22065,22068,22069,22063,22066,22062,22067,22064);
RegisterSet(PALADIN,nil, 22091,22093,22089,22088,22090,22086,22092,22087);
RegisterSet(PRIEST,nil,  22080,22082,22083,22079,22081,22078,22085,22084);
RegisterSet(ROGUE,nil,   22005,22008,22009,22004,22006,22002,22007,22003);
RegisterSet(SHAMAN,nil,  22097,22101,22102,22095,22099,22098,22100,22096);
RegisterSet(WARLOCK,nil, 22074,22073,22075,22071,22077,22070,22072,22076);
RegisterSet(WARRIOR,nil, 21999,22001,21997,21996,21998,21994,22000,21995);
-- ---------------------------------------------------------------------------
base = "D3"
RegisterSet(DRUID,HEALS, 28348,27737,28202,27468,27873);
RegisterSet(HUNTER,nil,  28275,27801,28228,27474,27874);
RegisterSet(MAGE,nil, 	 28278,27738,28229,27508,27838);
RegisterSet(PALADIN,TANK,28285,27739,28203,27535,27839);
RegisterSet(PRIEST,nil,  28413,27775,28230,27536,27875);
RegisterSet(ROGUE,nil, 	 28414,27776,28204,27509,27908);
RegisterSet(SHAMAN,DPS,  28349,27802,28231,27510,27909);
RegisterSet(WARLOCK,nil, 28415,27778,28232,27537,27948);
RegisterSet(WARRIOR,TANK,28350,27803,28205,27475,27977);
-- non-class specific sets
RegisterSet(RDPS,nil,   28193,27796,28191,27465,27907);
RegisterSet(FERAL,nil, 	28224,27797,28264,27531,27837);
RegisterSet(DPS,nil, 	28192,27713,28401,27528,27936);
RegisterSet(MDPS,nil, 	28225,27771,28403,27497,27870);
-- ---------------------------------------------------------------------------
base = "T1"
-- Druid
RegisterSet(nil,nil, 16834,16836,16833,16830,16831,16828,16835,16829);
-- Hunter
RegisterSet(nil,nil, 16846,16848,16845,16850,16852,16851,16847,16849);
-- Mage
RegisterSet(nil,nil, 16795,16797,16798,16799,16801,16802,16796,16800);
-- Paladin
RegisterSet(nil,nil, 16854,16856,16853,16857,16860,16858,16855,16859);
-- Priest
RegisterSet(nil,nil, 16813,16816,16815,16819,16812,16817,16814,16811);
-- Rogue
RegisterSet(nil,nil, 16821,16823,16820,16825,16826,16827,16822,16824);
-- Shaman
RegisterSet(nil,nil, 16842,16844,16841,16840,16839,16838,16843,16837);
-- Warlock
RegisterSet(nil,nil, 16808,16807,16809,16804,16805,16806,16810,16803);
-- Warrior
RegisterSet(nil,nil, 16866,16868,16865,16861,16863,16864,16867,16862);
-- ---------------------------------------------------------------------------
base = "T2"
-- Druid
RegisterSet(nil,nil, 16900,16902,16897,16904,16899,16903,16901,16898);
-- Hunter
RegisterSet(nil,nil, 16939,16937,16942,16935,16940,16936,16938,16941);
-- Mage
RegisterSet(nil,nil, 16914,16917,16916,16918,16913,16818,16915,16912);
-- Paladin
RegisterSet(nil,nil, 16955,16953,16958,16951,16956,16952,16954,16957);
-- Priest
RegisterSet(nil,nil, 16921,16924,16923,16926,16920,16925,16922,16919);
-- Rogue
RegisterSet(nil,nil, 16908,16832,16905,16911,16907,16910,16909,16906);
-- Shaman
RegisterSet(nil,nil, 16947,16945,16950,16943,16948,16944,16946,16949);
-- Warlock
RegisterSet(nil,nil, 16929,16932,16931,16934,16928,16933,16930,16927);
-- Warrior
RegisterSet(nil,nil, 16963,16961,16966,16959,16964,16960,16962,16965);
-- ---------------------------------------------------------------------------
base = "T3"
RegisterSet(DRUID,nil,   22490,22491,22488,22495,22493,22494,22489,22492,23064);
RegisterSet(HUNTER,nil,  22438,22439,22436,22443,22441,22442,22437,22440,23067);
RegisterSet(MAGE,nil,    22498,22499,22496,22503,22501,22502,22497,22500,23062);
RegisterSet(PALADIN,nil, 22428,22429,22425,22424,22426,22431,22427,22430,23066);
RegisterSet(PRIEST,nil,  22514,22515,22512,22519,22517,22518,22513,22516,23061);
RegisterSet(ROGUE,nil,   22478,22479,22476,22483,22481,22482,22477,22480,23060);
RegisterSet(SHAMAN,nil,  22466,22467,22464,22471,22469,22470,22465,22468,23065);
RegisterSet(WARLOCK,nil, 22506,22507,22504,22511,22509,22510,22505,22508,23063);
RegisterSet(WARRIOR,nil, 22418,22419,22416,22423,22421,22422,22417,22420,23059);
-- ---------------------------------------------------------------------------
base = "T4"
local srep = select(3,GetFactionInfoByID(934)) -- scryer rep
if srep and srep < 4 then 
  vendor = vmap(481, 24, 30) -- aldor
else
  vendor = vmap(481, 44, 90) -- scryer
end
-- Tokens
RegisterSet(TOKEN,nil, 29753,29754,29755, 29756,29757,29758, 29759,29760,29761, 29762,29763,29764, 29765,29766,29767);
-- Druid
RegisterSet(FERAL,nil, 29098,29100,29096,29097,29099);
RegisterSet(HEAL,nil, 29086,29089,29087,29090,29088);
RegisterSet(RDPS,nil, 29093,29095,29091,29092,29094);
-- Hunter
RegisterSet(nil,nil, 29081,29084,29082,29085,29083);
-- Mage
RegisterSet(nil,nil, 29076,29079,29077,29080,29078);
-- Paladin
RegisterSet(TANK,nil, 29068,29070,29066,29067,29069);
RegisterSet(DPS,nil, 29073,29075,29071,29072,29074);
RegisterSet(HEAL,nil, 29061,29064,29062,29065,29063);
-- Priest
RegisterSet(HEAL,nil, 29049,29054,29050,29055,29053);
RegisterSet(DPS,nil, 29058,29060,29056,29057,29059);
-- Rogue
RegisterSet(nil,nil, 29044,29047,29045,29048,29046);
-- Shaman
RegisterSet(MDPS,nil, 29040,29043,29038,29039,29042);
RegisterSet(HEAL,nil, 29028,29031,29029,29032,29030);
RegisterSet(RDPS,nil, 29035,29037,29033,29034,29036);
-- Warlock
RegisterSet(nil,nil, 28963,28967,28964,28968,28966);
-- Warrior
RegisterSet(TANK,nil, 29011,29016,29012,29017,29015);
RegisterSet(DPS,nil, 29021,29023,29019,29020,29022);

-- ---------------------------------------------------------------------------
base = "T5"
-- Tokens
RegisterSet(TOKEN,nil, 30236,30237,30238, 30239,30240,30241, 30242,30243,30244, 30245,30246,30247, 30248,30249,30250);
-- Druid
RegisterSet(FERAL,nil, 30228,30230,30222,30223,30229);
RegisterSet(HEAL,nil, 30219,30221,30216,30217,30220);
RegisterSet(RDPS,nil, 30233,30235,30231,30232,30234);
-- Hunter
RegisterSet(nil,nil, 30141,30143,30139,30140,30142);
-- Mage
RegisterSet(nil,nil, 30206,30210,30196,30205,30207);
-- Paladin
RegisterSet(TANK,nil, 30125,30127,30123,30124,30126);
RegisterSet(DPS,nil, 30131,30133,30129,30130,30132);
RegisterSet(HEAL,nil, 30136,30138,30134,30135,30137);
-- Priest
RegisterSet(HEAL,nil, 30152,30154,30150,30151,30153);
RegisterSet(DPS,nil, 30161,30163,30159,30160,30162);
-- Rogue
RegisterSet(nil,nil, 30146,30149,30144,30145,30148);
-- Shaman
RegisterSet(MDPS,nil, 30190,30194,30185,30189,30192);
RegisterSet(HEAL,nil, 30166,30168,30164,30165,30167);
RegisterSet(RDPS,nil, 30171,30173,30169,30170,30172);
-- Warlock
RegisterSet(nil,nil, 30212,30215,30214,30211,30213);
-- Warrior
RegisterSet(TANK,nil, 30115,30117,30113,30114,30116);
RegisterSet(DPS,nil, 30120,30122,30118,30119,30121);

-- ---------------------------------------------------------------------------
base = "T6"
-- Tokens
vendor = vmap(499, 50.2, 28.6) -- Isle of Quel'Danas (belt, boot, bracer)
RegisterSet(TOKEN,nil, 34853,34854,34855, 34856,34857,34858, 34848,34851,34852);

vendor = vmap(775) -- Mount Hyjal
RegisterSet(TOKEN,nil, 31089,31090,31091, 31092,31093,31094,
                        31095,31096,31097, 31098,31099,31100, 31101,31102,31103);
-- Druid
RegisterSet(FERAL,nil, 31039,31048,31042,34444,31034,34556,31044,34573);
RegisterSet(HEAL,nil, 31037,31047,31041,34445,31032,34554,31045,34571);
RegisterSet(RDPS,nil, 31040,31049,31043,34446,31035,34555,31046,34572);
-- Hunter
RegisterSet(nil,nil, 31003,31006,31004,34443,31001,34549,31005,34570);
-- Mage
RegisterSet(nil,nil, 31056,31059,31057,34447,31055,34557,31058,34574);
-- Paladin
RegisterSet(TANK,nil, 30987,30998,30991,34433,30985,34488,30995,34560);
RegisterSet(DPS,nil, 30989,30997,30990,34431,30982,34485,30993,34561);
RegisterSet(HEAL,nil, 30988,30996,30992,34432,30983,34487,30994,34559);
-- Priest
RegisterSet(HEAL,nil, 31063,31069,31066,34435,31060,34527,31068,34562);
RegisterSet(DPS,nil, 31064,31070,31065,34434,31061,34528,31067,34563);
-- Rogue
RegisterSet(nil,nil, 31027,31030,31028,34448,31026,34558,31029,34575);
-- Shaman
RegisterSet(MDPS,nil, 31015,31024,31018,34439,31011,34545,31021,34567);
RegisterSet(HEAL,nil, 31012,31022,31016,34438,31007,34543,31019,34565);
RegisterSet(RDPS,nil, 31014,31023,31017,34437,31008,34542,31020,34566);
-- Warlock
RegisterSet(nil,nil, 31051,31054,31052,34436,31050,34541,31053,34564);
-- Warrior
RegisterSet(TANK,nil, 30974,30980,30976,34442,30970,34547,30978,34568);
RegisterSet(DPS,nil, 30972,30979,30975,34441,30969,34546,30977,34569);

-- ---------------------------------------------------------------------------
base = "T7"
vendor = vmap(504) -- Dalaran
-- Tokens
RegisterSet(TOKEN,RAID10, 40610,40611,40612, 40613,40614,40615, 40616,40617,40618, 40619,40620,40621, 40622,40623,40624);
RegisterSet(TOKEN,RAID25, 40625,40626,40627, 40628,40629,40630, 40631,40632,40633, 40634,40635,40636, 40637,40638,40639);
-- Druid
RegisterSet(FERAL,RAID10, 39553,39556,39554,39557,39555);
RegisterSet(FERAL,RAID25, 40473,40494,40471,40472,40493);
RegisterSet(HEAL,RAID10, 39531,39542,39538,39543,39539);
RegisterSet(HEAL,RAID25, 40461,40465,40463,40460,40462);
RegisterSet(RDPS,RAID10, 39545,39548,39547,39544,39546);
RegisterSet(RDPS,RAID25, 40467,40470,40469,40466,40468);
-- Hunter
RegisterSet(nil,RAID10, 39578,39581,39579,39582,39580);
RegisterSet(nil,RAID25, 40505,40507,40503,40504,40506);
-- Mage
RegisterSet(nil,RAID10, 39491,39494,39492,39495,39493);
RegisterSet(nil,RAID25, 40416,40419,40418,40415,40417);
-- Paladin
RegisterSet(HEAL,RAID10, 39628,39631,39629,39632,39630);
RegisterSet(HEAL,RAID25, 40571,40573,40569,40570,40572);
RegisterSet(DPS,RAID10, 39635,39637,39633,39634,39636);
RegisterSet(DPS,RAID25, 40576,40578,40574,40575,40577);
RegisterSet(TANK,RAID10, 39640,39642,39638,39639,39641);
RegisterSet(TANK,RAID25, 40581,40584,40579,40580,40583);
-- Priest
RegisterSet(DPS,RAID10, 39521,39529,39523,39530,39528);
RegisterSet(DPS,RAID25, 40456,40459,40458,40454,40457);
RegisterSet(HEAL,RAID10, 39514,39518,39515,39519,39517);
RegisterSet(HEAL,RAID25, 40447,40450,40449,40445,40448);
-- Rogue
RegisterSet(nil,RAID10, 39561,39565,39558,39560,39564);
RegisterSet(nil,RAID25, 40499,40502,40495,40496,40500);
-- Shaman
RegisterSet(HEAL,RAID10, 39583,39590,39588,39591,39589);
RegisterSet(HEAL,RAID25, 40510,40513,40508,40509,40512);
RegisterSet(MDPS,RAID10, 39602,39604,39597,39601,39603);
RegisterSet(MDPS,RAID25, 40521,40524,40523,40520,40522);
RegisterSet(RDPS,RAID10, 39594,39596,39592,39593,39595);
RegisterSet(RDPS,RAID25, 40516,40518,40514,40515,40517);
-- Warlock
RegisterSet(nil,RAID10, 39496,39499,39497,39500,39498);
RegisterSet(nil,RAID25, 40421,40424,40423,40420,40422);
-- Warrior
RegisterSet(DPS,RAID10, 39605,39608,39606,39609,39607);
RegisterSet(DPS,RAID25, 40528,40530,40525,40527,40529);
RegisterSet(TANK,RAID10, 39610,39613,39611,39622,39612);
RegisterSet(TANK,RAID25, 40546,40548,40544,40545,40547);
-- Death Knight
RegisterSet(DPS,RAID10, 39619,39621,39617,39618,39620);
RegisterSet(DPS,RAID25, 40554,40557,40550,40552,40556);
RegisterSet(TANK,RAID10, 39625,39627,39623,39624,39626);
RegisterSet(TANK,RAID25, 40565,40568,40559,40563,40567);

-- ---------------------------------------------------------------------------
base = "T8"
vendor = vmap(504) -- Dalaran
-- Tokens
RegisterSet(TOKEN,RAID10, 45635,45636,45637, 45644,45645,45646, 45647,45648,45649, 45659,45660,45661, 45650,45651,45652);
RegisterSet(TOKEN,RAID25, 45632,45633,45634, 45641,45642,45643, 45638,45639,45640, 45656,45657,45658, 45653,45654,45655);
-- Druid
RegisterSet(FERAL,RAID10, 45356,45359,45358,45355,45357);
RegisterSet(FERAL,RAID25, 46161,46157,46159,46158,46160);
RegisterSet(HEAL,RAID10, 45346,45349,45348,45345,45347);
RegisterSet(HEAL,RAID25, 46184,46187,46186,46183,46185);
RegisterSet(RDPS,RAID10, 46313,45352,45354,45351,45353);
RegisterSet(RDPS,RAID25, 46191,46196,46194,46189,46192);
-- Hunter
RegisterSet(nil,RAID10, 45361,45363,45364,45360,45362);
RegisterSet(nil,RAID25, 46143,46145,46141,46142,46144);
-- Mage
RegisterSet(nil,RAID10, 45365,45369,45368,46131,45367);
RegisterSet(nil,RAID25, 46129,46134,46130,46132,46133);
-- Paladin
RegisterSet(HEAL,RAID10, 45372,45373,45374,45370,45371);
RegisterSet(HEAL,RAID25, 46180,46182,46178,46179,46181);
RegisterSet(DPS,RAID10, 45377,45380,45375,45376,45379);
RegisterSet(DPS,RAID25, 46156,46152,46154,46155,46153);
RegisterSet(TANK,RAID10, 45382,45385,45381,45383,45384);
RegisterSet(TANK,RAID25, 46175,46177,46173,46174,46176);
-- Priest
RegisterSet(DPS,RAID10, 45391,45393,45395,45392,45394);
RegisterSet(DPS,RAID25, 46172,46165,46168,46163,46170);
RegisterSet(HEAL,RAID10, 45386,45390,45389,45387,45388);
RegisterSet(HEAL,RAID25, 46197,46190,46193,46188,46195);
-- Rogue
RegisterSet(nil,RAID10, 45398,45400,45396,45397,45399);
RegisterSet(nil,RAID25, 46125,46127,46123,46124,46126);
-- Shaman
RegisterSet(HEAL,RAID10, 45402,45404,45405,45401,45403);
RegisterSet(HEAL,RAID25, 46201,46204,46198,46199,46202);
RegisterSet(MDPS,RAID10, 45412,45415,45413,45414,45416);
RegisterSet(MDPS,RAID25, 46212,46203,46205,46200,46208);
RegisterSet(RDPS,RAID10, 45408,45410,45411,45406,45409);
RegisterSet(RDPS,RAID25, 46209,46211,46206,46207,46210)
-- Warlock
RegisterSet(nil,RAID10, 45417,45422,45421,45419,45420);
RegisterSet(nil,RAID25, 46140,46136,46137,46135,46139);
-- Warrior
RegisterSet(DPS,RAID10, 45431,45433,45429,45430,45432);
RegisterSet(DPS,RAID25, 46151,46149,46146,46148,46150);
RegisterSet(TANK,RAID10, 45425,45428,45424,45426,45427);
RegisterSet(TANK,RAID25, 46166,46167,46164,46162,46169);
-- Death Knight
RegisterSet(DPS,RAID10, 45342,45344,45340,45341,45343);
RegisterSet(DPS,RAID25, 46115,46117,46111,46113,46116);
RegisterSet(TANK,RAID10, 45336,45339,45335,45337,45338);
RegisterSet(TANK,RAID25, 46120,46122,46118,46119,46121);

-- ---------------------------------------------------------------------------
base = "T9"
vendor = vmap(492, 75.4, 21.6) -- Icecrown
-- Tokens
RegisterSet(TOKEN,RAID25, 47242);
RegisterSet(TOKEN,HEROIC25, 47557, 47558, 47559);
-- Druid
RegisterSet(HEAL,EMBLEMS, 48102,48131,48129,48132,48130);
RegisterSet(HEAL,RAID25, 48134,48137,48136,48133,48135);
RegisterSet(HEAL,HEROIC25, 48141,48138,48139,48142,48140);
RegisterSet(HEAL,EMBLEMS, 48154,48157,48156,48153,48155);
RegisterSet(HEAL,RAID25, 48151,48148,48149,48152,48150);
RegisterSet(HEAL,HEROIC25, 48144,48147,48146,48143,48145);
RegisterSet(FERAL,EMBLEMS, 48214,48217,48216,48213,48215);
RegisterSet(FERAL,RAID25, 48211,48208,48209,48212,48210);
RegisterSet(FERAL,HEROIC25, 48204,48207,48206,48203,48205);
RegisterSet(FERAL,EMBLEMS, 48188,48191,48189,48192,48190);
RegisterSet(FERAL,RAID25, 48194,48197,48196,48193,48195);
RegisterSet(FERAL,HEROIC25, 48201,48198,48199,48202,48200);
RegisterSet(RDPS,EMBLEMS, 48158,48161,48159,48162,48160);
RegisterSet(RDPS,RAID25, 48164,48167,48166,48163,48165);
RegisterSet(RDPS,HEROIC25, 48171,48168,48169,48172,48170);
RegisterSet(RDPS,EMBLEMS, 48184,48187,48186,48183,48185);
RegisterSet(RDPS,RAID25, 48181,48178,48179,48182,48180);
RegisterSet(RDPS,HEROIC25, 48174,48177,48176,48173,48175);
-- Hunter
RegisterSet(nil,EMBLEMS, 48250,48253,48251,48254,48252);
RegisterSet(nil,RAID25, 48257,48259,48255,48256,48258);
RegisterSet(nil,HEROIC25, 48262,48260,48264,48263,48261);
RegisterSet(nil,EMBLEMS, 48277,48279,48275,48276,48278);
RegisterSet(nil,RAID25, 48272,48270,48274,48273,48271);
RegisterSet(nil,HEROIC25, 48267,48269,48265,48266,48268);
-- Mage
RegisterSet(nil,EMBLEMS, 47748,47751,47749,47752,47750);
RegisterSet(nil,RAID25, 47754,47757,47756,47753,47755);
RegisterSet(nil,HEROIC25, 47761,47758,47759,47762,47760);
RegisterSet(nil,EMBLEMS, 47774,47777,47776,47773,47775);
RegisterSet(nil,RAID25, 47771,47768,47769,47772,47770);
RegisterSet(nil,HEROIC25, 47764,47767,47766,47763,47765);
-- Paladin
RegisterSet(HEAL,EMBLEMS, 48564,48572,48566,48574,48568);
RegisterSet(HEAL,RAID25, 48577,48579,48575,48576,48578);
RegisterSet(HEAL,HEROIC25, 48582,48580,48584,48583,48581);
RegisterSet(HEAL,EMBLEMS, 48597,48595,48599,48598,48596);
RegisterSet(HEAL,RAID25, 48592,48590,48594,48593,48591);
RegisterSet(HEAL,HEROIC25, 48587,48585,48589,48588,48586);
RegisterSet(DPS,EMBLEMS, 48604,48606,48602,48603,48605);
RegisterSet(DPS,RAID25, 48609,48611,48607,48608,48610);
RegisterSet(DPS,HEROIC25, 48614,48612,48616,48615,48613);
RegisterSet(DPS,EMBLEMS, 48629,48627,48631,48630,48628);
RegisterSet(DPS,RAID25, 48624,48622,48626,48625,48623);
RegisterSet(DPS,HEROIC25, 48619,48621,48617,48618,48620);
RegisterSet(TANK,EMBLEMS, 48634,48636,48632,48633,48635);
RegisterSet(TANK,RAID25, 48639,48637,48641,48640,48638);
RegisterSet(TANK,HEROIC25, 48644,48646,48642,48643,48645);
RegisterSet(TANK,EMBLEMS, 48654,48656,48652,48653,48655);
RegisterSet(TANK,RAID25, 48659,48661,48657,48658,48660);
RegisterSet(TANK,HEROIC25, 48649,48647,48651,48650,48648);
-- Priest
RegisterSet(DPS,EMBLEMS, 48073,48076,48075,48072,48074);
RegisterSet(DPS,RAID25, 48078,48081,48080,48077,48079);
RegisterSet(DPS,HEROIC25, 48085,48082,48083,48086,48084);
RegisterSet(DPS,EMBLEMS, 48098,48101,48100,48097,48099);
RegisterSet(DPS,RAID25, 48095,48092,48093,48096,48094);
RegisterSet(DPS,HEROIC25, 48088,48091,48090,48087,48089);
RegisterSet(HEAL,EMBLEMS, 47914,47981,47936,47982,47980);
RegisterSet(HEAL,RAID25, 47984,47987,47986,47983,47985);
RegisterSet(HEAL,HEROIC25, 48035,48029,48031,48037,48033);
RegisterSet(HEAL,EMBLEMS, 48068,48071,48070,48067,48069);
RegisterSet(HEAL,RAID25, 48065,48062,48063,48066,48064);
RegisterSet(HEAL,HEROIC25, 48058,48061,48060,48057,48059);
-- Rogue
RegisterSet(nil,EMBLEMS, 48218,48221,48219,48222,48220);
RegisterSet(nil,RAID25, 48225,48227,48223,48224,48226);
RegisterSet(nil,HEROIC25, 48230,48228,48232,48231,48229);
RegisterSet(nil,EMBLEMS, 48245,48247,48243,48244,48246);
RegisterSet(nil,RAID25, 48240,48238,48242,48241,48239);
RegisterSet(nil,HEROIC25, 48235,48237,48233,48234,48236);
-- Shaman
RegisterSet(RDPS,EMBLEMS, 48313,48315,48310,48312,48314);
RegisterSet(RDPS,RAID25, 48318,48320,48316,48317,48319);
RegisterSet(RDPS,HEROIC25, 48323,48321,48325,48324,48322);
RegisterSet(RDPS,EMBLEMS, 48338,48340,48336,48337,48339);
RegisterSet(RDPS,RAID25, 48333,48331,48335,48334,48332);
RegisterSet(RDPS,HEROIC25, 48328,48330,48326,48327,48329);
RegisterSet(MDPS,EMBLEMS, 48343,48345,48341,48342,48344);
RegisterSet(MDPS,RAID25, 48348,48350,48346,48347,48349);
RegisterSet(MDPS,HEROIC25, 48353,48351,48355,48354,48352);
RegisterSet(MDPS,EMBLEMS, 48368,48370,48366,48367,48369);
RegisterSet(MDPS,RAID25, 48363,48361,48365,48364,48362);
RegisterSet(MDPS,HEROIC25, 48358,48360,48356,48357,48359);
RegisterSet(HEAL,EMBLEMS, 48280,48283,48281,48284,48282);
RegisterSet(HEAL,RAID25, 48287,48289,48285,48286,48288);
RegisterSet(HEAL,HEROIC25, 48292,48290,48294,48293,48291);
RegisterSet(HEAL,EMBLEMS, 48297,48299,48295,48296,48298);
RegisterSet(HEAL,RAID25, 48302,48304,48300,48301,48303);
RegisterSet(HEAL,HEROIC25, 48307,48309,48305,48306,48308);
-- Warlock
RegisterSet(nil,EMBLEMS, 47784,47787,47786,47783,47785);
RegisterSet(nil,RAID25, 47778,47781,47779,47782,47780);
RegisterSet(nil,HEROIC25, 47789,47792,47791,47788,47790);
RegisterSet(nil,EMBLEMS, 47801,47798,47799,47802,47800);
RegisterSet(nil,RAID25, 47804,47807,47806,47803,47805);
RegisterSet(nil,HEROIC25, 47796,47793,47794,47797,47795);
-- Warrior
RegisterSet(DPS,EMBLEMS, 48371,48374,48372,48375,48373);
RegisterSet(DPS,RAID25, 48378,48380,48376,48377,48379);
RegisterSet(DPS,HEROIC25, 48383,48381,48385,48384,48382);
RegisterSet(DPS,EMBLEMS, 48388,48390,48386,48387,48389);
RegisterSet(DPS,RAID25, 48393,48395,48391,48392,48394);
RegisterSet(DPS,HEROIC25, 48398,48400,48396,48397,48399);
RegisterSet(TANK,EMBLEMS, 48429,48448,48436,48449,48445);
RegisterSet(TANK,RAID25, 48430,48454,48450,48452,48446);
RegisterSet(TANK,HEROIC25, 48433,48455,48451,48453,48447);
RegisterSet(TANK,EMBLEMS, 48458,48460,48456,48457,48459);
RegisterSet(TANK,RAID25, 48463,48465,48461,48462,48464);
RegisterSet(TANK,HEROIC25, 48468,48470,48466,48467,48469);
-- Death Knight
RegisterSet(DPS,EMBLEMS, 48472,48478,48474,48480,48476);
RegisterSet(DPS,RAID25, 48483,48485,48481,48482,48484);
RegisterSet(DPS,HEROIC25, 48488,48486,48490,48489,48487);
RegisterSet(DPS,EMBLEMS, 48503,48505,48501,48502,48504);
RegisterSet(DPS,RAID25, 48498,48496,48500,48499,48497);
RegisterSet(DPS,HEROIC25, 48493,48495,48491,48492,48494);
RegisterSet(TANK,EMBLEMS, 48529,48535,48531,48537,48533);
RegisterSet(TANK,RAID25, 48540,48542,48538,48539,48541);
RegisterSet(TANK,HEROIC25, 48545,48543,48547,48546,48544);
RegisterSet(TANK,EMBLEMS, 48560,48562,48558,48559,48561);
RegisterSet(TANK,RAID25, 48555,48553,48557,48556,48554);
RegisterSet(TANK,HEROIC25, 48550,48552,48548,48549,48551);

-- ---------------------------------------------------------------------------
base = "T10"
vendor = vmap(604)..", "..vmap(504) -- ICC, Dalaran
-- Tokens
RegisterSet(TOKEN,RAID25, 52025, 52026, 52027);
RegisterSet(TOKEN,HEROIC25, 52028, 52029, 52030);
-- Druid
RegisterSet(HEAL,EMBLEMS, 50108,50113,50106,50107,50109);
RegisterSet(HEAL,RAID25, 51137,51135,51139,51138,51136);
RegisterSet(HEAL,HEROIC25, 51302,51304,51300,51301,51303);
RegisterSet(FERAL,EMBLEMS, 50826,50824,50828,50827,50825);
RegisterSet(FERAL,RAID25, 51143,51140,51141,51144,51142);
RegisterSet(FERAL,HEROIC25, 51296,51299,51298,51295,51297);
RegisterSet(RDPS,EMBLEMS, 50821,50819,50823,50822,50820);
RegisterSet(RDPS,RAID25, 51149,51147,51145,51148,51146);
RegisterSet(RDPS,HEROIC25, 51290,51292,51294,51291,51293);
-- Hunter
RegisterSet(nil,EMBLEMS, 50115,50117,50118,50114,50116);
RegisterSet(nil,RAID25, 51153,51151,51150,51154,51152);
RegisterSet(nil,HEROIC25, 51286,51288,51289,51285,51287);
-- Mage
RegisterSet(nil,EMBLEMS, 50276,50279,50278,50275,50277);
RegisterSet(nil,RAID25, 51158,51155,51156,51159,51157);
RegisterSet(nil,HEROIC25, 51281,51284,51283,51280,51282);
-- Paladin
RegisterSet(HEAL,EMBLEMS, 50867,50865,50869,50868,50866);
RegisterSet(HEAL,RAID25, 51167,51166,51165,51169,51168);
RegisterSet(HEAL,HEROIC25, 51272,51273,51274,51270,51271);
RegisterSet(DPS,EMBLEMS, 50326,50324,50328,50327,50325);
RegisterSet(DPS,RAID25, 51162,51160,51164,51163,51161);
RegisterSet(DPS,HEROIC25, 51277,51279,51275,51276,51278);
RegisterSet(TANK,EMBLEMS, 50862,50860,50864,50863,50861);
RegisterSet(TANK,RAID25, 51173,51170,51174,51172,51171);
RegisterSet(TANK,HEROIC25, 51266,51269,51265,51267,51268);
-- Priest
RegisterSet(DPS,EMBLEMS, 50392,50396,50394,50391,50393);
RegisterSet(DPS,RAID25, 51184,51182,51180,51183,51181);
RegisterSet(DPS,HEROIC25, 51255,51257,51259,51256,51258);
RegisterSet(HEAL,EMBLEMS, 50765,50767,50768,50766,50769);
RegisterSet(HEAL,RAID25, 51178,51175,51176,51179,51177);
RegisterSet(HEAL,HEROIC25, 51261,51264,51263,51260,51262);
-- Rogue
RegisterSet(nil,EMBLEMS, 50089,50105,50087,50088,50090);
RegisterSet(nil,RAID25, 51187,51185,51189,51188,51186);
RegisterSet(nil,HEROIC25, 51252,51254,51250,51251,51253);
-- Shaman
RegisterSet(RDPS,EMBLEMS, 50843,50845,50841,50842,50844);
RegisterSet(RDPS,RAID25, 51202,51204,51200,51201,51203);
RegisterSet(RDPS,HEROIC25, 51237,51235,51239,51238,51236);
RegisterSet(MDPS,EMBLEMS, 50832,50834,50830,50831,50833);
RegisterSet(MDPS,RAID25, 51197,51199,51195,51196,51198);
RegisterSet(MDPS,HEROIC25, 51242,51240,51244,51243,51241);
RegisterSet(HEAL,EMBLEMS, 50837,50839,50835,50836,50838);
RegisterSet(HEAL,RAID25, 51192,51194,51190,51191,51193);
RegisterSet(HEAL,HEROIC25, 51247,51245,51249,51248,51246);
-- Warlock
RegisterSet(nil,EMBLEMS, 50241,50244,50243,50240,50242);
RegisterSet(nil,RAID25, 51208,51205,51206,51209,51207);
RegisterSet(nil,HEROIC25, 51231,51234,51233,51230,51232);
-- Warrior
RegisterSet(DPS,EMBLEMS, 50080,50082,50078,50079,50081);
RegisterSet(DPS,RAID25, 51212,51210,51214,51213,51211);
RegisterSet(DPS,HEROIC25, 51227,51229,51225,51226,51228);
RegisterSet(TANK,EMBLEMS, 50848,50846,50850,50849,50847);
RegisterSet(TANK,RAID25, 51218,51215,51219,51217,51216);
RegisterSet(TANK,HEROIC25, 51221,51224,51220,51222,51223);
-- Death Knight
RegisterSet(DPS,EMBLEMS, 50096,50098,50094,50095,50097);
RegisterSet(DPS,RAID25, 51127,51125,51129,51128,51126);
RegisterSet(DPS,HEROIC25, 51312,51314,51310,51311,51313);
RegisterSet(TANK,EMBLEMS, 50855,50853,50857,50856,50854);
RegisterSet(TANK,RAID25, 51133,51130,51134,51132,51131);
RegisterSet(TANK,HEROIC25, 51306,51309,51305,51307,51308);

-- ---------------------------------------------------------------------------
base = "T11"
vendor = vmap(301, 79, 70, 321, 48.2, 71.6) -- Stormwind, Orgrimmar
-- Tokens
RegisterSet(TOKEN,nil, 63682,63683,63684,64314,64315,64316);
RegisterSet(TOKEN,HEROIC,67431,67430,67429,67423,67424,67425,67426,67427,67428,65000,65001,65002,65087,65088,65089);
-- Druid
RegisterSet(HEAL,nil, 60277,60279,60278,60280,60276);
RegisterSet(HEAL,HEROIC, 65195,65196,65197,65198,65194);
RegisterSet(FERAL,nil, 60286,60289,60288,60287,60290);
RegisterSet(FERAL,HEROIC, 65189,65190,65191,65192,65193);
RegisterSet(RDPS,nil, 60282,60284,60283,60285,60281);
RegisterSet(RDPS,HEROIC, 65199,65200,65201,65202,65203);

-- Hunter
RegisterSet(nil,nil, 60303,60304,60305,60306,60307);
RegisterSet(nil,HEROIC, 65204,65205,65206,65207,65208);

-- Mage
RegisterSet(nil,nil, 60243,60244,60245,60246,60247);
RegisterSet(nil,HEROIC, 65209,65210,65211,65212,65213);

-- Paladin
RegisterSet(HEAL,nil, 60359,60360,60361,60362,60363);
RegisterSet(HEAL,HEROIC, 65219,65220,65221,65222,65223);
RegisterSet(DPS,nil, 60344,60345,60346,60347,60348);
RegisterSet(DPS,HEROIC, 65214,65215,65216,65217,65218);
RegisterSet(TANK,nil, 60354,60355,60356,60357,60358);
RegisterSet(TANK,HEROIC, 65224,65225,65226,65227,65228);

-- Priest
RegisterSet(DPS,nil, 60253,60254,60255,60256,60257);
RegisterSet(DPS,HEROIC, 65234,65235,65236,65237,65238);
RegisterSet(HEAL,nil, 60258,60262,60261,60275,60259);
RegisterSet(HEAL,HEROIC, 65229,65230,65231,65232,65233);

-- Rogue
RegisterSet(nil,nil, 60298,60299,60300,60301,60302);
RegisterSet(nil,HEROIC, 65239,65240,65241,65242,65243);

-- Shaman
RegisterSet(RDPS,nil, 60314,60315,60316,60317,60313);
RegisterSet(RDPS,HEROIC, 65254,65255,65256,65257,65258);
RegisterSet(MDPS,nil, 60318,60319,60320,60321,60322);
RegisterSet(MDPS,HEROIC, 65249,65250,65251,65252,65253);
RegisterSet(HEAL,nil, 60308,60309,60310,60311,60312);
RegisterSet(HEAL,HEROIC, 65244,65245,65246,65247,65248);

-- Warlock
RegisterSet(nil,nil, 60249,60250,60251,60252,60248);
RegisterSet(nil,HEROIC, 65259,65260,65261,65262,65263);

-- Warrior
RegisterSet(DPS,nil, 60323,60324,60325,60326,60327);
RegisterSet(DPS,HEROIC, 65264,65265,65266,65267,65268);
RegisterSet(TANK,nil, 60328,60329,60330,60331,60332);
RegisterSet(TANK,HEROIC, 65269,65270,65271,65272,65273);

-- Death Knight
RegisterSet(DPS,nil, 60339,60340,60341,60342,60343);
RegisterSet(DPS,HEROIC, 65179,65180,65181,65182,65183);
RegisterSet(TANK,nil, 60349,60350,60351,60352,60353);
RegisterSet(TANK,HEROIC, 65184,65185,65186,65187,65188);

-- ---------------------------------------------------------------------------
base = "T12"
vendor = vmap(301, 79, 69.6, 321, 48.4, 71.6) -- Stormwind, Orgrimmar
-- Tokens
RegisterSet(TOKEN,nil, 71675,71682,71668,71681,71688,71674);
RegisterSet(TOKEN,HEROIC, 71679,71686,71672,71677,71684,71670,71676,71683,71669,71678,71685,71671,71680,71687,71673);
-- Druid
RegisterSet(HEAL,nil, 71103,71106,71105,71102,71104);
RegisterSet(HEAL,HEROIC, 71492,71495,71494,71491,71493);
RegisterSet(FERAL,nil, 71098,71101,71100,71097,71099);
RegisterSet(FERAL,HEROIC, 71488,71490,71486,71487,71489);
RegisterSet(RDPS,nil, 71108,71111,71110,71107,71109);
RegisterSet(RDPS,HEROIC, 71497,71500,71499,71496,71498);

-- Hunter
RegisterSet(nil,nil, 71051,71053,71054,71050,71052);
RegisterSet(nil,HEROIC, 71503,71505,71501,71502,71504);

-- Mage
RegisterSet(nil,nil, 71287,71290,71289,71286,71288);
RegisterSet(nil,HEROIC, 71508,71511,71510,71507,71509);

-- Paladin
RegisterSet(HEAL,nil, 71093,71095,71091,71092,71094);
RegisterSet(HEAL,HEROIC, 71519,71521,71517,71518,71520);
RegisterSet(DPS,nil, 71065,71067,71063,71064,71066);
RegisterSet(DPS,HEROIC, 71514,71516,71512,71513,71515);
RegisterSet(TANK,nil, 70948,70946,70950,70949,70947);
RegisterSet(TANK,HEROIC, 71524,71526,71522,71523,71525);

-- Priest
RegisterSet(DPS,nil, 71277,71280,71279,71276,71278);
RegisterSet(DPS,HEROIC, 71533,71536,71535,71532,71534);
RegisterSet(HEAL,nil, 71272,71275,71274,71271,71273);
RegisterSet(HEAL,HEROIC, 71528,71531,71530,71527,71529);

-- Rogue
RegisterSet(nil,nil, 71047,71049,71045,71046,71048);
RegisterSet(nil,HEROIC, 71539,71541,71537,71538,71540);

-- Shaman
RegisterSet(RDPS,nil, 71293,71295,71294,71292,71291);
RegisterSet(RDPS,HEROIC, 71554,71556,71552,71553,71555);
RegisterSet(MDPS,nil, 71303,71305,71301,71302,71304);
RegisterSet(MDPS,HEROIC, 71549,71551,71547,71548,71550);
RegisterSet(HEAL,nil, 71298,71300,71296,71297,71299);
RegisterSet(HEAL,HEROIC, 71544,71546,71542,71543,71545);

-- Warlock
RegisterSet(nil,nil, 71282,71285,71284,71281,71283);
RegisterSet(nil,HEROIC, 71595,71598,71597,71594,71596);

-- Warrior
RegisterSet(DPS,nil, 71070,71072,71068,71069,71071);
RegisterSet(DPS,HEROIC, 71599,71603,71600,71601,71602);
RegisterSet(TANK,nil, 70944,70941,70945,70943,70942);
RegisterSet(TANK,HEROIC, 71606,71608,71604,71605,71607);

-- Death Knight
RegisterSet(DPS,nil, 71060,71062,71058,71059,71061);
RegisterSet(DPS,HEROIC, 71478,71480,71476,71477,71479);
RegisterSet(TANK,nil, 70954,70951,70955,70953,70952);
RegisterSet(TANK,HEROIC, 71483,71485,71481,71482,71484);

-- ---------------------------------------------------------------------------
base = "T13"
vendor = vmap(301, 79, 69.6, 321, 48.6, 71.6) -- Stormwind, Orgrimmar
-- Tokens
RegisterSet(TOKEN,LFR,    78862,78863,78864, 78868,78869,78870, 78865,78866,78867, 78871,78872,78873, 78874,78875,78876);
RegisterSet(TOKEN,NORMAL, 78174,78179,78184, 78182,78177,78172, 78183,78178,78173, 78181,78176,78171, 78180,78175,78170);
RegisterSet(TOKEN,HEROIC, 78847,78848,78849, 78850,78851,78852, 78853,78854,78855, 78856,78857,78858, 78859,78860,78861);
-- Druid
RegisterSet(HEAL,LFR,    78785,78835,78755,78775,78805);
RegisterSet(HEAL,NORMAL, 76750,76753,76752,76749,76751);
RegisterSet(HEAL,HEROIC, 78690,78740,78660,78680,78710);
RegisterSet(FERAL,LFR,    78789,78838,78760,78779,78808);
RegisterSet(FERAL,NORMAL, 77015,77017,77013,77014,77016);
RegisterSet(FERAL,HEROIC, 78694,78743,78665,78684,78713);
RegisterSet(RDPS,LFR,    78791,78839,78757,78771,78809);
RegisterSet(RDPS,NORMAL, 77019,77022,77021,77018,77020);
RegisterSet(RDPS,HEROIC, 78696,78744,78662,78676,78714);

-- Hunter
RegisterSet(nil,LFR,    78793,78832,78756,78769,78804);
RegisterSet(nil,NORMAL, 77030,77032,77028,77029,77031);
RegisterSet(nil,HEROIC, 78698,78737,78661,78674,78709);

-- Mage
RegisterSet(nil,LFR,    78796,78843,78824,78766,78815);
RegisterSet(nil,NORMAL, 76213,76216,76215,76212,76214);
RegisterSet(nil,HEROIC, 78701,78748,78729,78671,78720);

-- Paladin
RegisterSet(HEAL,LFR,    78787,78841,78821,78768,78812);
RegisterSet(HEAL,NORMAL, 76767,76769,76765,76766,76768);
RegisterSet(HEAL,HEROIC, 78692,78746,78726,78673,78717);
RegisterSet(TANK,LFR,    78790,78840,78827,78772,78810);
RegisterSet(TANK,NORMAL, 77005,77007,77003,77004,77006);
RegisterSet(TANK,HEROIC, 78695,78745,78732,78677,78715);
RegisterSet(DPS,LFR,    78788,78837,78822,78770,78807);
RegisterSet(DPS,NORMAL, 76876,76878,76874,76875,76877);
RegisterSet(DPS,HEROIC, 78693,78742,78727,78675,78712);

-- Priest
RegisterSet(DPS,LFR,    78798,78845,78826,78777,78817);
RegisterSet(DPS,NORMAL, 76347,76344,76345,76348,76346);
RegisterSet(DPS,HEROIC, 78703,78750,78731,78682,78722);
RegisterSet(HEAL,LFR,    78795,78842,78823,78778,78814);
RegisterSet(HEAL,NORMAL, 76358,76361,76360,76357,76359);
RegisterSet(HEAL,HEROIC, 78700,78747,78728,78683,78719);

-- Rogue
RegisterSet(nil,LFR,    78794,78833,78759,78774,78803);
RegisterSet(nil,NORMAL, 77025,77027,77023,77024,77026);
RegisterSet(nil,HEROIC, 78699,78738,78664,78679,78708);

-- Shaman
RegisterSet(RDPS,LFR,    78780,78836,78818,78761,78806);
RegisterSet(RDPS,NORMAL, 77037,77035,77039,77038,77036);
RegisterSet(RDPS,HEROIC, 78685,78741,78723,78666,78711);
RegisterSet(MDPS,LFR,    78781,78828,78819,78762,78799);
RegisterSet(MDPS,NORMAL, 77042,77044,77040,77041,77043);
RegisterSet(MDPS,HEROIC, 78686,78733,78724,78667,78704);
RegisterSet(HEAL,LFR,    78786,78834,78820,78767,78813);
RegisterSet(HEAL,NORMAL, 76758,76760,76756,76757,76759);
RegisterSet(HEAL,HEROIC, 78691,78739,78725,78672,78718);

-- Warlock
RegisterSet(nil,LFR,    78797,78844,78825,78776,78816);
RegisterSet(nil,NORMAL, 76342,76339,76340,76343,76341);
RegisterSet(nil,HEROIC, 78702,78749,78730,78681,78721);

-- Warrior
RegisterSet(DPS,LFR,    78783,78830,78752,78763,78801);
RegisterSet(DPS,NORMAL, 76983,76987,76984,76985,76986);
RegisterSet(DPS,HEROIC, 78688,78735,78657,78668,78706);
RegisterSet(TANK,LFR,    78784,78829,78753,78764,78800);
RegisterSet(TANK,NORMAL, 76990,76992,76988,76989,76991);
RegisterSet(TANK,HEROIC, 78689,78734,78658,78669,78705);

-- Death Knight
RegisterSet(DPS,LFR,    78782,78831,78754,78765,78802);
RegisterSet(DPS,NORMAL, 76976,76978,76974,76975,76977);
RegisterSet(DPS,HEROIC, 78687,78736,78659,78670,78707);
RegisterSet(TANK,LFR,    78792,78846,78758,78773,78811);
RegisterSet(TANK,NORMAL, 77010,77012,77008,77009,77011);
RegisterSet(TANK,HEROIC, 78697,78751,78663,78678,78716);
-- ---------------------------------------------------------------------------
base = "T14"
vendor = vmap(810, 37.8, 64.6) -- Townlong Steppes
-- Tokens
RegisterSet(TOKEN,LFR,    89264,89265,89266,89267,89268,89269,89270,89271,89272,89273,89274,89275,89276,89277,89278);
RegisterSet(TOKEN,NORMAL, 89234,89235,89236,89237,89238,89239,89240,89241,89242,89243,89244,89245,89246,89247,89248);
RegisterSet(TOKEN,HEROIC, 89249,89250,89251,89252,89253,89254,89255,89256,89257,89258,89259,89260,89261,89262,89263);
-- Druid
RegisterSet(HEAL,LFR,    86697,86694,86695,86646,86698);
RegisterSet(HEAL,NORMAL, 85357,85354,85355,85306,85358);
RegisterSet(HEAL,HEROIC, 86929,86932,86931,86935,86928);
RegisterSet(TANK,LFR,    86721,86723,86719,86722,86720);
RegisterSet(TANK,NORMAL, 85381,85383,85379,85382,85380);
RegisterSet(TANK,HEROIC, 86940,86942,86938,86941,86939);
RegisterSet(MDPS,LFR,    86651,86649,86653,86650,86652);
RegisterSet(MDPS,NORMAL, 85311,85309,85313,85310,85312);
RegisterSet(MDPS,HEROIC, 86925,86927,86923,86926,86924);
RegisterSet(RDPS,LFR,    86647,86644,86645,86696,86648);
RegisterSet(RDPS,NORMAL, 85307,85304,85305,85356,85308);
RegisterSet(RDPS,HEROIC, 86934,86937,86936,86930,86933);

-- Hunter
RegisterSet(nil,LFR,    86636,86634,86638,86635,86637);
RegisterSet(nil,NORMAL, 85296,85294,85298,85295,85297);
RegisterSet(nil,HEROIC, 87004,87006,87002,87005,87003);

-- Mage
RegisterSet(nil,LFR,    86717,86714,86715,86716,86718);
RegisterSet(nil,NORMAL, 85377,85374,85375,85376,85378);
RegisterSet(nil,HEROIC, 87008,87011,87010,87009,87007);

-- Monk
RegisterSet(HEAL,LFR,    86730,86733,86732,86731,86729);
RegisterSet(HEAL,NORMAL, 85390,85393,85392,85391,85389);
RegisterSet(HEAL,HEROIC, 87090,87093,87092,87091,87089);
RegisterSet(TANK,LFR,    86726,86724,86728,86725,86727);
RegisterSet(TANK,NORMAL, 85386,85384,85388,85385,85387);
RegisterSet(TANK,HEROIC, 87096,87098,87094,87097,87095);
RegisterSet(DPS,LFR,    86736,86738,86734,86737,86735);
RegisterSet(DPS,NORMAL, 85396,85398,85394,85397,85395);
RegisterSet(DPS,HEROIC, 87086,87088,87084,87087,87085);

-- Paladin
RegisterSet(HEAL,LFR,    86686,86684,86688,86687,86685);
RegisterSet(HEAL,NORMAL, 85346,85344,85348,85347,85345);
RegisterSet(HEAL,HEROIC, 87106,87108,87104,87105,87107);
RegisterSet(TANK,LFR,    86661,86659,86663,86660,86662);
RegisterSet(TANK,NORMAL, 85321,85319,85323,85320,85322);
RegisterSet(TANK,HEROIC, 87111,87113,87109,87112,87110);
RegisterSet(DPS,LFR,    86681,86679,86683,86680,86682);
RegisterSet(DPS,NORMAL, 85341,85339,85343,85340,85342);
RegisterSet(DPS,HEROIC, 87101,87103,87099,87102,87100);

-- Priest
RegisterSet(DPS,LFR,    86705,86708,86707,86706,86704);
RegisterSet(DPS,NORMAL, 85365,85368,85367,85366,85364);
RegisterSet(DPS,HEROIC, 87120,87123,87122,87121,87119);
RegisterSet(HEAL,LFR,    86702,86699,86700,86701,86703);
RegisterSet(HEAL,NORMAL, 85362,85359,85360,85361,85363);
RegisterSet(HEAL,HEROIC, 87115,87118,87117,87116,87114);

-- Rogue
RegisterSet(nil,LFR,    86641,86639,86643,86640,86642);
RegisterSet(nil,NORMAL, 85301,85299,85303,85300,85302);
RegisterSet(nil,HEROIC, 87126,87128,87124,87127,87125);

-- Shaman
RegisterSet(RDPS,LFR,    86631,86633,86629,86630,86632);
RegisterSet(RDPS,NORMAL, 85291,85289,85293,85290,85292);
RegisterSet(RDPS,HEROIC, 87141,87143,87139,87140,87142);
RegisterSet(MDPS,LFR,    86626,86624,86628,86625,86627);
RegisterSet(MDPS,NORMAL, 85286,85284,85288,85285,85287);
RegisterSet(MDPS,HEROIC, 87136,87138,87134,87137,87135);
RegisterSet(HEAL,LFR,    86691,86689,86693,86690,86692);
RegisterSet(HEAL,NORMAL, 85351,85349,85353,85350,85352);
RegisterSet(HEAL,HEROIC, 87131,87133,87129,87132,87130);

-- Warlock
RegisterSet(nil,LFR,    86710,86713,86712,86711,86709);
RegisterSet(nil,NORMAL, 85370,85373,85372,85371,85369);
RegisterSet(nil,HEROIC, 87188,87191,87190,87189,87187);

-- Warrior
RegisterSet(DPS,LFR,    86673,86669,86672,86670,86671);
RegisterSet(DPS,NORMAL, 85333,85329,85332,85330,85331);
RegisterSet(DPS,HEROIC, 87192,87196,87193,87195,87194);
RegisterSet(TANK,LFR,    86666,86664,86668,86665,86667);
RegisterSet(TANK,NORMAL, 85326,85324,85328,85325,85327);
RegisterSet(TANK,HEROIC, 87199,87201,87197,87200,87198);

-- Death Knight
RegisterSet(DPS,LFR,    86676,86674,86678,86675,86677);
RegisterSet(DPS,NORMAL, 85336,85334,85338,85335,85337);
RegisterSet(DPS,HEROIC, 86915,86917,86913,86916,86914);
RegisterSet(TANK,LFR,    86656,86654,86658,86655,86657);
RegisterSet(TANK,NORMAL, 85316,85314,85318,85315,85317);
RegisterSet(TANK,HEROIC, 86920,86922,86918,86921,86919);
-- ---------------------------------------------------------------------------
base = "T15"
vendor = vmap(810, 37.8, 64.6) -- Townlong Steppes
-- Tokens
RegisterSet(TOKEN,LFR,    95823,95824,95822,95856,95857,95855,95880,95881,95879,95888,95889,95887,95956,95957,95955)
RegisterSet(TOKEN,NORMAL, 95574,95579,95569,95575,95580,95570,95577,95582,95571,95576,95581,95572,95578,95583,95573)
RegisterSet(TOKEN,HEROIC, 96567,96568,96566,96600,96601,96599,96624,96625,96623,96632,96633,96631,96700,96701,96699)
--RegisterSet(TOKEN,NORMALTH, 96195,96196,96194,96228,96229,96227,96252,96253,96251,96260,96261,96259,96328,96329,?????)
--RegisterSet(TOKEN,HEROICTH, 96939,96940,96938,96972,96973,96971,96996,96997,96995,97004,97005,97003,97072,97073,97071)

-- Druid
RegisterSet(HEAL,LFR,   95840,95841,95842,95844,95843)
RegisterSet(HEAL,NORMAL,95240,95241,95242,95244,95243)
RegisterSet(HEAL,HEROIC,96584,96585,96586,96588,96587)
RegisterSet(TANK,LFR,   95853,95851,95852,95854,95850)
RegisterSet(TANK,NORMAL,95253,95251,95252,95254,95250)
RegisterSet(TANK,HEROIC,96597,96595,96596,96598,96594)
RegisterSet(MDPS,LFR,   95836,95837,95838,95835,95839)
RegisterSet(MDPS,NORMAL,95236,95237,95238,95235,95239)
RegisterSet(MDPS,HEROIC,96580,96581,96582,96579,96583)
RegisterSet(RDPS,LFR,   95846,95845,95847,95849,95848)
RegisterSet(RDPS,NORMAL,95246,95245,95247,95249,95248)
RegisterSet(RDPS,HEROIC,96590,96589,96591,96593,96592)

-- Hunter
RegisterSet(nil,LFR,    95883,95884,95885,95886,95882)
RegisterSet(nil,NORMAL, 95256,95257,95258,95259,95255)
RegisterSet(nil,HEROIC, 96627,96628,96629,96630,96626)

-- Mage
RegisterSet(nil,LFR,    95890,95891,95892,95894,95893)
RegisterSet(nil,NORMAL, 95260,95261,95262,95264,95263)
RegisterSet(nil,HEROIC, 96634,96635,96636,96638,96637)

-- Monk
RegisterSet(HEAL,LFR,   95900,95901,95902,95904,95903)
RegisterSet(HEAL,NORMAL,95270,95271,95272,95274,95273)
RegisterSet(HEAL,HEROIC,96644,96645,96646,96648,96647)
RegisterSet(TANK,LFR,   95905,95907,95906,95908,95909)
RegisterSet(TANK,NORMAL,95275,95277,95276,95278,95279)
RegisterSet(TANK,HEROIC,96649,96651,96650,96652,96653)
RegisterSet(DPS,LFR,    95896,95897,95898,95899,95895)
RegisterSet(DPS,NORMAL, 95266,95267,95268,95269,95265)
RegisterSet(DPS,HEROIC, 96640,96641,96642,96643,96639)

-- Paladin
RegisterSet(HEAL,LFR,   95915,95916,95918,95917,95919)
RegisterSet(HEAL,NORMAL,95285,95286,95288,95287,95289)
RegisterSet(HEAL,HEROIC,96659,96660,96662,96661,96663)
RegisterSet(TANK,LFR,   95920,95922,95921,95923,95924)
RegisterSet(TANK,NORMAL,95290,95292,95291,95293,95294)
RegisterSet(TANK,HEROIC,96664,96666,96665,96667,96668)
RegisterSet(DPS,LFR,    95910,95911,95912,95913,95914)
RegisterSet(DPS,NORMAL, 95280,95281,95282,95283,95284)
RegisterSet(DPS,HEROIC, 96654,96655,96656,96657,96658)

-- Priest
RegisterSet(DPS,LFR,    95930,95931,95932,95933,95934)
RegisterSet(DPS,NORMAL, 95300,95301,95302,95303,95304)
RegisterSet(DPS,HEROIC, 96674,96675,96676,96677,96678)
RegisterSet(HEAL,LFR,   95926,95925,95927,95929,95928)
RegisterSet(HEAL,NORMAL,95296,95295,95297,95299,95298)
RegisterSet(HEAL,HEROIC,96670,96669,96671,96673,96672)

-- Rogue
RegisterSet(nil,LFR,    95936,95937,95938,95939,95935)
RegisterSet(nil,NORMAL, 95306,95307,95308,95309,95305)
RegisterSet(nil,HEROIC, 96680,96681,96682,96683,96679)

-- Shaman
RegisterSet(RDPS,LFR,   95951,95950,95952,95953,95954)
RegisterSet(RDPS,NORMAL,95321,95320,95322,95323,95324)
RegisterSet(RDPS,HEROIC,96695,96694,96696,96697,96698)
RegisterSet(MDPS,LFR,   95945,95946,95947,95948,95949)
RegisterSet(MDPS,NORMAL,95315,95316,95317,95318,95319)
RegisterSet(MDPS,HEROIC,96689,96690,96691,96692,96693)
RegisterSet(HEAL,LFR,   95942,95941,95943,95944,95940)
RegisterSet(HEAL,NORMAL,95312,95311,95313,95314,95310)
RegisterSet(HEAL,HEROIC,96686,96685,96687,96688,96684)

-- Warlock
RegisterSet(nil,LFR,    95981,95982,95983,95985,95984)
RegisterSet(nil,NORMAL, 95325,95326,95327,95329,95328)
RegisterSet(nil,HEROIC, 96725,96726,96727,96729,96728)

-- Warrior
RegisterSet(DPS,LFR,    95987,95988,95986,95989,95990)
RegisterSet(DPS,NORMAL, 95331,95332,95330,95333,95334)
RegisterSet(DPS,HEROIC, 96731,96732,96730,96733,96734)
RegisterSet(TANK,LFR,   95991,95993,95992,95994,95995)
RegisterSet(TANK,NORMAL,95335,95337,95336,95338,95339)
RegisterSet(TANK,HEROIC,96735,96737,96736,96738,96739)

-- Death Knight
RegisterSet(DPS,LFR,    95825,95826,95828,95827,95829)
RegisterSet(DPS,NORMAL, 95225,95226,95228,95227,95229)
RegisterSet(DPS,HEROIC, 96569,96570,96572,96571,96573)
RegisterSet(TANK,LFR,   95830,95832,95831,95833,95834)
RegisterSet(TANK,NORMAL,95230,95232,95231,95233,95234)
RegisterSet(TANK,HEROIC,96574,96576,96575,96577,96578)
-- ---------------------------------------------------------------------------
base = "T16"
vendor = vmap(905,54,82,903,42,77) -- Shrine Ally/Horde
-- Tokens
RegisterSet(TOKEN,LFR,    99668,99671,99674,99677,99680,99669,99672,99675,99678,99681,99667,99670,99673,99676,99679, 105862,105861,105860)
RegisterSet(TOKEN,FLEX,   99742,99745,99748,99751,99754,99743,99746,99749,99752,99755,99744,99747,99750,99753,99756, 105865,105864,105863)
RegisterSet(TOKEN,NORMAL, 99696,99682,99683,99684,99685,99691,99686,99687,99688,99689,99690,99692,99693,99694,99695, 105859,105858,105857)
RegisterSet(TOKEN,HEROIC, 99714,99717,99720,99723,99726,99712,99715,99718,99721,99724,99713,99716,99719,99722,99725, 105868,105867,105866)

-- Druid
RegisterSet(RDPS,LFR,   98995,98998,98997,98996,98994) -- 102 = Balance
RegisterSet(RDPS,FLEX,  99618,99621,99620,99619,99617)
RegisterSet(RDPS,NORMAL,99175,99169,99177,99176,99174)
RegisterSet(RDPS,HEROIC,99433,99428,99427,99434,99432)
RegisterSet(MDPS,LFR,   99043,99022,99041,99044,99042) -- 103 = Feral
RegisterSet(MDPS,FLEX,  99599,99589,99632,99600,99633)
RegisterSet(MDPS,NORMAL,99182,99184,99180,99183,99181)
RegisterSet(MDPS,HEROIC,99328,99322,99326,99329,99327)
RegisterSet(TANK,LFR,   99001,98978,98999,98981,99000) -- 104 = Guardian
RegisterSet(TANK,FLEX,  99624,99664,99622,99610,99623)
RegisterSet(TANK,NORMAL,99164,99166,99170,99165,99163)
RegisterSet(TANK,HEROIC,99421,99423,99419,99422,99420)
RegisterSet(HEAL,LFR,   99013,99016,99015,99014,99012) -- 105 = Restoration
RegisterSet(HEAL,FLEX,  99638,99583,99582,99581,99637)
RegisterSet(HEAL,NORMAL,99178,99173,99172,99171,99185)
RegisterSet(HEAL,HEROIC,99436,99431,99430,99429,99435)

-- Hunter
RegisterSet(nil,LFR,    99080,99082,99085,99081,99086)
RegisterSet(nil,FLEX,   99660,99574,99577,99573,99578)
RegisterSet(nil,NORMAL, 99157,99159,99167,99158,99168)
RegisterSet(nil,HEROIC, 99402,99404,99405,99403,99406)

-- Mage
RegisterSet(nil,LFR,    99084,99079,99078,99077,99083)
RegisterSet(nil,FLEX,   99576,99659,99658,99657,99575)
RegisterSet(nil,NORMAL, 99161,99153,99152,99162,99160)
RegisterSet(nil,HEROIC, 99398,99401,99400,99399,99397)

-- Monk
RegisterSet(TANK,LFR,   99065,99051,99063,99050,99064) -- 268 = Brewmaster
RegisterSet(TANK,FLEX,  99607,99565,99643,99606,99644)
RegisterSet(TANK,NORMAL,99142,99144,99140,99143,99141)
RegisterSet(TANK,HEROIC,99384,99386,99382,99385,99383)
RegisterSet(DPS,LFR,    99073,99075,99071,99074,99072) -- 269 = Windwalker
RegisterSet(DPS,FLEX,   99653,99655,99555,99654,99556)
RegisterSet(DPS,NORMAL, 99156,99146,99154,99145,99155)
RegisterSet(DPS,HEROIC, 99393,99395,99396,99394,99392)
RegisterSet(HEAL,LFR,   99069,99062,99061,99070,99068) -- 270 = Mistweaver
RegisterSet(HEAL,FLEX,  99553,99642,99641,99554,99552)
RegisterSet(HEAL,NORMAL,99148,99151,99150,99149,99147)
RegisterSet(HEAL,HEROIC,99389,99381,99391,99390,99388)

-- Paladin
RegisterSet(HEAL,LFR,   98979,99076,99003,98980,98982) -- 65 = Holy
RegisterSet(HEAL,FLEX,  99665,99656,99626,99666,99648)
RegisterSet(HEAL,NORMAL,99135,99125,99133,99124,99134)
RegisterSet(HEAL,HEROIC,99376,99378,99374,99377,99375)
RegisterSet(TANK,LFR,   99029,99027,99031,99026,99028) -- 66 = Protection
RegisterSet(TANK,FLEX,  99596,99594,99598,99593,99595)
RegisterSet(TANK,NORMAL,99128,99130,99126,99129,99127)
RegisterSet(TANK,HEROIC,99370,99364,99368,99371,99369)
RegisterSet(DPS,LFR,    98985,98987,99052,98986,99002) -- 67 = Retribution
RegisterSet(DPS,FLEX,   99651,99662,99566,99661,99625)
RegisterSet(DPS,NORMAL, 99138,99132,99136,99139,99137)
RegisterSet(DPS,HEROIC, 99379,99373,99387,99372,99380)

-- Priest
RegisterSet(HEAL,LFR,   99024,99018,99017,99025,99023) -- 256 = Discipline, 257 = Holy
RegisterSet(HEAL,FLEX,  99591,99585,99584,99592,99590)
RegisterSet(HEAL,NORMAL,99117,99120,99119,99118,99131)
RegisterSet(HEAL,HEROIC,99366,99358,99357,99367,99365)
RegisterSet(DPS,LFR,    99020,99005,99004,99021,99019) -- 258 = Shadow
RegisterSet(DPS,FLEX,   99587,99628,99627,99588,99586)
RegisterSet(DPS,NORMAL, 99122,99111,99110,99123,99121)
RegisterSet(DPS,HEROIC, 99360,99363,99362,99361,99359)

-- Rogue
RegisterSet(nil,LFR,    99008,99010,99006,99009,99007)
RegisterSet(nil,FLEX,   99631,99635,99629,99634,99630)
RegisterSet(nil,NORMAL, 99114,99116,99112,99115,99113)
RegisterSet(nil,HEROIC, 99348,99350,99356,99349,99355)

-- Shaman
RegisterSet(RDPS,LFR,   99089,99091,99087,99090,99088) -- 262 = Elemental
RegisterSet(RDPS,FLEX,  99645,99647,99579,99646,99580)
RegisterSet(RDPS,NORMAL,99093,99095,99106,99094,99092)
RegisterSet(RDPS,HEROIC,99332,99334,99344,99333,99345)
RegisterSet(MDPS,LFR,   98983,98977,98992,98984,98993) -- 263 = Enhancement
RegisterSet(MDPS,FLEX,  99649,99663,99615,99650,99616)
RegisterSet(MDPS,NORMAL,99103,99105,99101,99104,99102)
RegisterSet(MDPS,HEROIC,99341,99343,99347,99342,99340)
RegisterSet(HEAL,LFR,   98989,98991,99011,98990,98988) -- 264 = Restoration
RegisterSet(HEAL,FLEX,  99612,99614,99636,99613,99611)
RegisterSet(HEAL,NORMAL,99109,99100,99107,99099,99108)
RegisterSet(HEAL,HEROIC,99353,99346,99351,99354,99352)

-- Warlock
RegisterSet(nil,LFR,    99054,99045,99056,99055,99053)
RegisterSet(nil,FLEX,   99568,99601,99570,99569,99567)
RegisterSet(nil,NORMAL, 99097,99205,99204,99098,99096)
RegisterSet(nil,HEROIC, 99425,99417,99416,99426,99424)

-- Warrior
RegisterSet(DPS,LFR,    99046,99036,99047,99035,99034) -- 71 = Arms, 72 = Fury
RegisterSet(DPS,FLEX,   99602,99561,99603,99560,99559)
RegisterSet(DPS,NORMAL, 99206,99200,99197,99199,99198)
RegisterSet(DPS,HEROIC, 99418,99414,99411,99413,99412)
RegisterSet(TANK,LFR,   99032,99030,99037,99033,99038) -- 73 = Protection
RegisterSet(TANK,FLEX,  99557,99597,99562,99558,99563)
RegisterSet(TANK,NORMAL,99203,99196,99201,99195,99202)
RegisterSet(TANK,HEROIC,99409,99407,99415,99410,99408)

-- Death Knight
RegisterSet(TANK,LFR,   99049,99040,99060,99039,99048) -- 250 = Blood
RegisterSet(TANK,FLEX,  99605,99652,99640,99564,99604)
RegisterSet(TANK,NORMAL,99190,99179,99188,99191,99189)
RegisterSet(TANK,HEROIC,99323,99325,99330,99324,99331)
RegisterSet(DPS,LFR,    99057,99059,99066,99058,99067) -- 251 = Frost, 252 = Unholy
RegisterSet(DPS,FLEX,   99571,99639,99608,99572,99609)
RegisterSet(DPS,NORMAL, 99194,99187,99192,99186,99193)
RegisterSet(DPS,HEROIC, 99337,99339,99335,99338,99336)
-- ---------------------------------------------------------------------------
end

local function GetIDFromLink(link)
	if link == nil then return 0; end
	local id = string.match(link, "item:(%d+)");
	return tonumber(id);
end

local function OnTooltipSetItemHook(tooltip, ...)
	local itemName, itemLink = tooltip:GetItem();
	local itemID = GetIDFromLink(itemLink);
	if (itemID and Sets[itemID]) then
		tooltip:AddLine(ITEM_SET_BONUS:format(Sets[itemID]), 1, 1, 0);
	end
	if origTooltips[tooltip] then
		return origTooltips[tooltip](tooltip, ...);
	end
end

SetupSets();

local hookTooltips = {};
hookTooltips[GameTooltip] = 1; -- mouseover
hookTooltips[ItemRefTooltip] = 1; -- clicked
if (AtlasLootTooltip) then hookTooltips[AtlasLootTooltip] = 1; end

for tt in pairs(hookTooltips) do
	local origHook = tt:GetScript("OnTooltipSetItem");
	if (origHook ~= OnTooltipSetItemHook) then
		origTooltips[tt] = origHook;
		tt:SetScript("OnTooltipSetItem", OnTooltipSetItemHook);
	end
end
